/*!\file: Vertices.h
 * \brief prototypes for Vertices.h
 */ 

#ifndef _CONTAINER_VERTICES_H_
#define  _CONTAINER_VERTICES_H_

/*forward declarations */
class Materials;
class Parameters;
class Elements;
class Vertices;
class Loads;
class Nodes;
class DataSet;
class Inputs;

class Vertices: public DataSet{

	public:

		/*constructors, destructors: {{{1*/
		Vertices();
		Vertices(int enum_type);
		~Vertices();
		/*}}}*/
		/*numerics: {{{1*/
		void  CreatePartitioningVector(Vec* ppartition,int numobjects);
		void  DistributeDofs(int numberofnodes,int numdofspernode);
		void  FlagClones(int numberofnodes);
		int   NumberOfVertices(void);
		void  Ranks(int* ranks);
		/*}}}*/

};



#endif //ifndef _VERTICES_H_

